<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Student_Subject extends Controller_UserEnvi {

    public function action_show()
    {
        
        // ЛОГИКА
        $db = new Model_Student;
        $id = $this->request->param('id');
        
        $discipline = $db->getDisciplineMap($this->UserInfo['StudentID'], $id);
        $info = $db->getDisciplineInfoByID($id)->offsetGet(0);
        
        // Информация о предмете
        $subject['Title'] = $info['SubjectName'];
        if($info['ExamType'] == 'exam')
        {
            $subject['Control'] = 'Экзамен';
        }
        elseif($info['ExamType'] == 'credit')
        {
            $subject['Control'] = 'Зачет';
        }
        $subject['LectionCount'] = $info['LectionCount'];
        $subject['PracticeCount'] = $info['PracticeCount'];
		$subject['LabCount'] = $info['LabCount'];
        $subject['DepName'] = $info['DepName'];
        $subject['Teachers'] = $this->getTeachersForDiscipline($id);
        $semester = $db->getSemesterInfo($info['SemesterID']);
        $semester['SemesterNum'] = $semester['SemesterNum'] == 1 ? 'Осенний' : 'Весенний';
        $subject['SemesterNum'] = $semester['SemesterNum'];
        $subject['SemesterYear'] = $semester['SemesterYear'];
        // Учебная карта дисциплины
        $disciplineHandled = array();
        $rate = 0; $maxRate = 0; $i = 0; $id = 0;
        foreach($discipline as $row)
        {
            if($row['ModuleType'] == 'exam')
            {
                $disciplineHandled['Exam']['Rate'] = (int) $row['Rate'];
                $disciplineHandled['Exam']['MaxRate'] = (int) $row['MaxRate'];
                $disciplineHandled['Exam']['Date'] = $row['Date'];
            }
            elseif($row['ModuleType'] == 'bonus')
            {
                $disciplineHandled['Bonus']['Description'] = $row['Description'];
                $disciplineHandled['Bonus']['Rate'] = (int) $row['Rate'];
                $disciplineHandled['Bonus']['MaxRate'] = (int) $row['MaxRate'];
                $disciplineHandled['Bonus']['Date'] = $row['Date'];
            }
            else
            {
                if($row['ModuleID'] != $id)
                {
                    $i++;
                    $id = $row['ModuleID'];
                }

                if(!isset($disciplineHandled['Modules'][$i]['SubmodulesCount']))
                {
                    $disciplineHandled['Modules'][$i]['SubmodulesCount'] = 0;
                    $disciplineHandled['Modules'][$i]['Rate'] = 0;
                    $disciplineHandled['Modules'][$i]['MaxRate'] = 0;
                }

                $j = $disciplineHandled['Modules'][$i]['SubmodulesCount'] += 1;
                $disciplineHandled['Modules'][$i]['Rate'] += (int) $row['Rate'];
                $disciplineHandled['Modules'][$i]['MaxRate'] += (int) $row['MaxRate'];
                $disciplineHandled['Modules'][$i]['Title'] = $row['ModuleName'];

                $disciplineHandled['Modules'][$i]['Submodules'][$j]['Title'] = $row['SubModuleName'];
                $disciplineHandled['Modules'][$i]['Submodules'][$j]['Description'] = $row['SubmoduleDescription'];
                $disciplineHandled['Modules'][$i]['Submodules'][$j]['Rate'] = (int) $row['Rate'];
                $disciplineHandled['Modules'][$i]['Submodules'][$j]['Date'] = $row['Date'];
                $disciplineHandled['Modules'][$i]['Submodules'][$j]['MaxRate'] = (int) $row['MaxRate'];
            }
            $rate += $row['Rate'];
            $maxRate += $row['MaxRate'];
        }
        $disciplineHandled['ModulesCount'] = $i;
        $disciplineHandled['Rate'] = (int) $rate;
        $disciplineHandled['MaxRate'] = (int) $maxRate;
        
        // ПРЕДСТАВЛЕНИЕ 
        $twig = Twig::factory('student/subject');
        $twig->User = $this->UserInfo;
        $twig->Discipline = $subject;
        $twig->DisciplineMap = $disciplineHandled;
        $this->response->body($twig);
    }
    
    protected function getTeachersForDiscipline($id) {
        $model = new Model_Student;
        $teachers = $model->getTeachersForDiscipline($id);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++;
            $teachersHandled[$i] = $teacher['TeacherLast'].' '.$teacher['TeacherFirst'].' ';
            if(!empty($teacher['TeacherSecond']))
            {
                $teachersHandled[$i] .= $teacher['TeacherSecond'];
            }
        }
        return $teachersHandled;
    }        
}          